#import "Comptroller.h"
#import "XWGrid.h"

@implementation Comptroller
- (IBAction)go:(id)sender {
	if ([width intValue]<2) return;
	if ([height intValue]<2) return;
	XWGrid * grid = [[XWGrid alloc] initWithWidth:[width intValue] height:[height intValue]];
	NSString * wordsString = [[words stringValue] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	wordsString = [wordsString uppercaseString];
	NSArray * wordStrings = [wordsString componentsSeparatedByString:@" "];
	NSMutableArray * wordList = [NSMutableArray arrayWithCapacity:[wordStrings count]];
	for (NSString * string in wordStrings) {
		if ([string length]>1) {
			[wordList addObject:[XWWord wordWithString:string]];
		}
	}
	
	NSLog([wordList description]);
	
	resultsString = [NSMutableString stringWithCapacity:0];
	[self findAllSolutionsForWords:wordList inGrid:grid];	
	[results setString:resultsString];
	[results setFont:[NSFont fontWithName:@"Monaco" size:9.0]];
	[grid release];
}

- (void)findAllSolutionsForWords:(NSArray *)wordList inGrid:(XWGrid *)grid {
	int wordCount = [wordList count];
	XWLocation moves[wordCount];
	
	[self testWords:wordList onGrid:(XWGrid *)grid depth:0 moves:moves];
}

- (BOOL)testWords:(NSArray *)wordList onGrid:(XWGrid *)grid depth:(int)depth moves:(XWLocation *)moves {
	int wordCount = [wordList count];
	if (depth >= wordCount) {
		NSLog([grid description]);
		[resultsString appendString:[grid description]];
		[resultsString appendString:@"\n"];
		return NO;
	}
	
	XWWord * testWord = [wordList objectAtIndex:depth];
	for (int y=0; y<grid.height; y++) {
		for (int x=0; x<grid.width; x++) {
			XWLocation testLoc;
			testLoc.x = x;
			testLoc.y = y;
			testLoc.orientation = XWOrientationHorizontal;
			if ([grid word:testWord fitsAt:testLoc]) {
				[grid addCellsFromWord:testWord atLocation:testLoc];
				[self testWords:wordList onGrid:(XWGrid *)grid depth:depth+1 moves:moves];
				[grid undoLastWord];
			}
			testLoc.orientation = XWOrientationVertical;
			if ([grid word:testWord fitsAt:testLoc]) {
				[grid addCellsFromWord:testWord atLocation:testLoc];
				[self testWords:wordList onGrid:(XWGrid *)grid depth:depth+1 moves:moves];
				[grid undoLastWord];
			}
		}
	}
	return YES;
}

@end
