//
//  XWGrid.h
//  Crossword
//
//  Created by Max Williams on 28/12/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "XWLetter.h"
#import "XWWord.h"
#import "XWCell.h"

@interface XWGrid : NSObject {
	unsigned int width;
	unsigned int height;
	
	NSArray * cells;
	NSUndoManager * undoManager;
}

@property (readonly) unsigned int width;
@property (readonly) unsigned int height;
@property (readonly, assign) NSArray * cells;

- (id)initWithWidth:(unsigned int)initWidth height:(unsigned int)initHeight;
- (XWLetter *)letterAtX:(int)x Y:(int)y;
- (void)setLetter:(XWLetter *)letter atX:(int)x Y:(int)y;
- (XWCell *)cellAtX:(int)x Y:(int)y;
- (BOOL)word:(XWWord *)word fitsAt:(XWLocation)loc;
- (NSString *)description;
- (void)addCellsFromWord:(XWWord *)word atLocation:(XWLocation)loc;
- (void)undoLastWord;

@end
