//
//  XWLetterController.m
//  Crossword
//
//  Created by Max Williams on 03/01/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "XWLetterController.h"


@implementation XWLetterController

static XWLetterController * sharedControllerInstance = nil;

- (int)segmentIndexForString:(NSString *)string {
	if ([string isEqualToString:@"A"]) return  0;
	if ([string isEqualToString:@"B"]) return  1;
	if ([string isEqualToString:@"C"]) return  2;
	if ([string isEqualToString:@"D"]) return  3;
	if ([string isEqualToString:@"E"]) return  4;
	if ([string isEqualToString:@"F"]) return  5;
	if ([string isEqualToString:@"G"]) return  6;
	if ([string isEqualToString:@"H"]) return  7;
	if ([string isEqualToString:@"I"]) return  8;
	if ([string isEqualToString:@"J"]) return  9;
	if ([string isEqualToString:@"K"]) return 10;
	if ([string isEqualToString:@"L"]) return 11;
	if ([string isEqualToString:@"M"]) return 12;
	if ([string isEqualToString:@"N"]) return 13;
	if ([string isEqualToString:@"O"]) return 14;
	if ([string isEqualToString:@"P"]) return 15;
	if ([string isEqualToString:@"Q"]) return 16;
	if ([string isEqualToString:@"R"]) return 17;
	if ([string isEqualToString:@"S"]) return 18;
	if ([string isEqualToString:@"T"]) return 19;
	if ([string isEqualToString:@"U"]) return 20;
	if ([string isEqualToString:@"V"]) return 21;
	if ([string isEqualToString:@"W"]) return 22;
	if ([string isEqualToString:@"X"]) return 23;
	if ([string isEqualToString:@"Y"]) return 24;
	if ([string isEqualToString:@"Z"]) return 25;
	if ([string isEqualToString:@" "]) return 26;
	if ([string isEqualToString:@"§"]) return 27;
	if ([string isEqualToString:@"&"]) return 28;
	return -1;
}

- (id)init {
	if (![super init]) return nil;
	lettersForStrings = [[NSMutableDictionary alloc] initWithCapacity:27];
	return self;
}

- (void)dealloc {
	[lettersForStrings release];
	[super dealloc];
}

+ (XWLetterController *)sharedController {
    @synchronized(self) {
        if (sharedControllerInstance == nil) {
            [[self alloc] init]; // assignment not done here
        }
    }
    return sharedControllerInstance;
}

+ (id)allocWithZone:(NSZone *)zone {
    @synchronized(self) {
        if (sharedControllerInstance == nil) {
            sharedControllerInstance = [super allocWithZone:zone];
            return sharedControllerInstance;  // assignment and return on first allocation
        }
    }
    return nil; //on subsequent allocation attempts return nil
}

- (id)copyWithZone:(NSZone *)zone {
    return self;
}

- (id)retain {
    return self;
}

- (unsigned)retainCount {
    return UINT_MAX;  //denotes an object that cannot be released
}

- (void)release {
    //do nothing
}

- (id)autorelease {
    return self;
}

- (XWLetter *)letterForString:(NSString *)string {
	if (![string length]>0) {
		NSLog(@"letterForString: invalid string");
		return nil;
	}
	
	XWLetter * letter = [lettersForStrings objectForKey:string];
	if (letter!=nil) return letter;
		
	letter = [[XWLetter alloc] initWithString:string];
	[lettersForStrings setObject:letter forKey:string];
	return letter;
}

@end
