//
//  XWWord.m
//  Crossword
//
//  Created by Max Williams on 28/12/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "XWWord.h"

XWLocation XWMakeLocationWithOrientation(int x, int y, XWOrientation orientation) {
	XWLocation location;
	location.x = x;
	location.y = y;
	location.orientation = orientation;
	return location;
}

XWLocation XWMakeLocation(int x, int y) {
	XWLocation location;
	location.x = x;
	location.y = y;
	return location;
}

@implementation XWWord

@synthesize length;

+ (XWWord *)wordWithString:(NSString *)string {
	XWWord * word = [[[XWWord alloc] initWithString:string] autorelease];
	return word;
}

- (id)initWithString:(NSString *)string {
	if (![super init]) return nil;
	NSMutableArray *tempLetters = [[NSMutableArray alloc] initWithCapacity:[string length]];
	
	NSString * stringToAdd;
	XWLetter * letterToAdd;
	
	for (int i=0; i<[string length]; i++) {
		stringToAdd = [string substringWithRange:NSMakeRange(i, 1)];
		letterToAdd = [XWLetter letterForString:stringToAdd];
		[tempLetters addObject:letterToAdd];
	}
	
	letters = [[NSArray arrayWithArray:tempLetters] retain];
	[tempLetters release];
	
	length = [letters count];
	
	return self;
}

- (NSString *)description {
	NSMutableString * description = [NSMutableString stringWithCapacity:[letters count]];
	for (XWLetter * letter in letters) {
		[description appendString:[letter description]];
	}
	return description;
}

- (XWLetter *)letterAtIndex:(unsigned int)index {
	return [letters objectAtIndex:index];
}

@end
